﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DotNetCore.CAP;
using Hotline.Share.Dtos.Knowledge;
using Hotline.Share.Dtos.Order;
using Hotline.Share.Enums.Order;
using Hotline.Share.Mq;
using MapsterMapper;
using Microsoft.Extensions.Logging;
using XF.Domain.Dependency;
using XF.Domain.Repository;

namespace DataSharing.Application.Province
{
    public class ProvinceReceiver : ICapSubscribe, IScopeDependency
    {
        private readonly IRepository<DsOrder> _orderRepository;
        private readonly IMapper _mapper;
        private readonly ILogger<ProvinceReceiver> _logger;

        public ProvinceReceiver(
            IRepository<DsOrder> orderRepository,
            IMapper mapper,
            ILogger<ProvinceReceiver> logger)
        {
            _orderRepository = orderRepository;
            _mapper = mapper;
            _logger = logger;
        }

        //#region 协同-第一批次

        ///// <summary>
        ///// 退回申请    --已对接---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task GetCaseBackApply(PublishOrderSendBackDto dto, CancellationToken cancellationToken)
        //{
        //    //处理110退回事件
        //    if (dto.Order.Source == ESource.Police110)
        //    {
        //        var checkData = await _policeSendChainDealDsRepository.AnyAsync(p => p.AlarmReceiptNumber == dto.Order.ExternalId && p.DisposalType == (int)EDsDisposalType.Return, cancellationToken);
        //        if (!checkData)
        //        {
        //            var data = new DsPoliceSendChainDealDs()
        //            {
        //                OrderId = dto.Order.Id,
        //                AlarmReceiptNumber = dto.Order.ExternalId,
        //                ReturnName = dto.SendBack.CreatorName,
        //                ReturnUnit = dto.SendBack.CreatorOrgName,
        //                ReturnOpinion = dto.SendBack.Content,
        //                ReturnTime = dto.SendBack.CreationTime,
        //                WarehousingTime = DateTime.Now,
        //                DisposalType = 2
        //            };
        //            var id = await _policeSendChainDealDsRepository.AddAsync(data, cancellationToken);
        //            if (!string.IsNullOrEmpty(id))//如果数据新增成功直接调用业务系统退回接口，反馈退回成功
        //            { }  // await _hotlineClient.OrderSendBackResultAsync(new() { Id = dto.SendBack.Id }, default);

        //        }
        //    }

        //    //处理省上的退回申请
        //    if (dto.Order.Source == ESource.ProvinceStraight)
        //    {
        //        var data = _mapper.Map<DsGetCaseBackApply>(dto);

        //        data.CliengGuid = Guid.NewGuid().ToString();
        //        //将上报信息写入本地库
        //        data.Id = await _getCaseBackApplyRepository.AddAsync(data, cancellationToken);

        //        //将待推送数据写入待推送表
        //        await InitPushData("GetCaseBackApply", System.Text.Json.JsonSerializer.Serialize(data), "get_case_back_apply", data.Id, 0, cancellationToken);

        //        //   await _pusherProviderService.GetCaseBackApplyPusher(data, cancellationToken);

        //        //处理附件
        //        await FileData(dto.SendBack.FileJson, dto.Order.ProvinceNo, data.CliengGuid, dto.Order.AreaCode, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 服务工单督办过程  --已对接-----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SendSuperviseProcessInfo(PublishSuperviseDto dto, CancellationToken cancellationToken)
        //{
        //    //工单是省上派下来的，才能进行督办回复
        //    if (dto.Order.Source == ESource.ProvinceStraight && dto.Order.IsProvince)
        //    {
        //        var data = _mapper.Map<DsSendSuperviseProcessInfo>(dto);
        //        //将上报信息写入本地库
        //        data.Id = await _sendSuperviseProcessInfoRepository.AddAsync(data, cancellationToken);
        //        //将待推送数据写入待推送表
        //        await InitPushData("SendSuperviseProcessInfo", System.Text.Json.JsonSerializer.Serialize(data), "send_supervise_process_info", data.Id, 0, cancellationToken);

        //        //推送数据
        //        // await _pusherProviderService.SendSuperviseProcessInfoPusher(data, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 服务工单督办结果  --已对接----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SendSuperviseResultInfo(PublishSuperviseDto dto, CancellationToken cancellationToken)
        //{
        //    //工单是省上派下来的，才能进行督办回复
        //    if (dto.Order.Source == ESource.ProvinceStraight && dto.Order.IsProvince)
        //    {
        //        var data = _mapper.Map<DsSendSuperviseResultInfo>(dto);
        //        data.CliengGuid = Guid.NewGuid().ToString();
        //        //将上报信息写入本地库
        //        data.Id = await _sendSuperviseResultInfoRepository.AddAsync(data, cancellationToken);

        //        //将待推送数据写入待推送表
        //        await InitPushData("SendSuperviseResultInfo", System.Text.Json.JsonSerializer.Serialize(data), "send_supervise_result_info", data.Id, 0, cancellationToken);
        //        //处理附件
        //        await FileData(dto.Supervise.FileJson, dto.Order.ProvinceNo, data.CliengGuid, dto.Order.AreaCode, cancellationToken);
        //        // await _pusherProviderService.SendSuperviseResultInfoPusher(data, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 工单发起甄别  --已对接---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task ScreenCaseInfoSend(PublishScreenDto dto, CancellationToken cancellationToken)
        //{
        //    //如果是省上派下来的工单，才能调发起甄别的接口
        //    if (dto.Order.Source == ESource.ProvinceStraight && dto.Order.IsProvince)
        //    {
        //        var data = _mapper.Map<DsScreenCaseInfoSend>(dto);
        //        data.CliengGuid = Guid.NewGuid().ToString();
        //        data.ApplyType = dto.Screen.TypeDicName switch
        //        {
        //            "违反法律法规" => "10",
        //            "按正常流程处理" => "20",
        //            _ => "30",
        //        };

        //        //将上报信息写入本地库
        //        data.Id = await _screenCaseInfoSendRepository.AddAsync(data, cancellationToken);

        //        //将待推送数据写入待推送表
        //        await InitPushData("ScreenCaseInfoSend", System.Text.Json.JsonSerializer.Serialize(data), "screen_case_info_send", data.Id, 0, cancellationToken);
        //        //处理附件
        //        await FileData(dto.Screen.FileJson, dto.Order.ProvinceNo, data.CliengGuid, dto.Order.AreaCode, cancellationToken);
        //        //  await _pusherProviderService.ScreenCaseInfoSendPusher(data, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 服务工单申请延时   --已对接---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task DelayCaseInfoSend(PublishOrderDelayDto dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsDelayCaseInfoSend>(dto);
        //    data.CliengGuid = Guid.NewGuid().ToString();
        //    data.ApplyType = "1";
        //    //将上报信息写入本地库
        //    data.Id = await _delayCaseInfoSendRepository.AddAsync(data);

        //    //将待推送数据写入待推送表
        //    await InitPushData("DelayCaseInfoSend", System.Text.Json.JsonSerializer.Serialize(data), "delay_case_info_send", data.Id, 0, cancellationToken);

        //    //信息上报
        //    //   await _pusherProviderService.DelayCaseInfoSendPusher(data, cancellationToken);
        //    //处理附件
        //    await FileData(dto.FileJson, data.CaseSerial, data.CliengGuid, data.AreaCode, cancellationToken);
        //}

        ///// <summary>
        ///// 政民互动提交公开---已在接收大补数据中实现  
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task ZmhdCaseInfoPublic(ZmhdCaseInfoPublicInfo dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsZmhdCaseInfoPublic>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    //将上报信息写入本地库
        //    data.Id = await _zMHDCaseInfoPublicRepository.AddAsync(data);

        //    //将待推送数据写入待推送表
        //    await InitPushData("ZmhdCaseInfoPublic", System.Text.Json.JsonSerializer.Serialize(data), "zmhd_case_info_public", data.Id, 0, cancellationToken);

        //    //信息上报
        //    //  await _pusherProviderService.ZmhdCaseInfoPublicPusher(data, cancellationToken);
        //}
        //#endregion

        //#region 汇聚-第二批次

        ///// <summary>
        ///// 热线工单流程开启 --服务工单受理----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task OrderFlowStarted(OrderDto dto, CancellationToken cancellationToken)
        //{
        //    //如果不是省上派下来的工单，需要汇聚到省上
        //    if (!dto.IsProvince)
        //    {
        //        var submitCaseInfo = await InitData(dto, cancellationToken);
        //        //处理数据
        //        var dataOrder = await _dataOrderRepository.GetAsync(p => p.OrderId == submitCaseInfo.OrderID, cancellationToken);
        //        if (dataOrder == null)
        //        {
        //            dataOrder = new()
        //            {
        //                OrderId = submitCaseInfo.OrderID,
        //                OrderNo = submitCaseInfo.No,
        //                ProvinceNo = submitCaseInfo.CaseSerial,
        //                CaseDate = submitCaseInfo.CaseDate,
        //                FirstSyncProvinceTime = DateTime.Now,
        //                SyncInterval = 0,
        //                IsTimelyUpload = true,
        //                CaseSource = dto.SourceChannel,
        //                CaseSourceCode = dto.SourceChannelCode,
        //                ExpiredTime = submitCaseInfo.TfdBackTimeBf,
        //                CaseType = dto.AcceptType,
        //                CaseTypeCode = dto.AcceptTypeCode,
        //                AllDuration = 0,
        //                IsProvince = false,
        //                HandleState = "办理中",
        //                Title = dto.Title,
        //                FromName = dto.FromName,
        //                Contact = dto.Contact,
        //                Content = dto.Content,
        //                HotspotId = dto.HotspotId,
        //                HotspotName = dto.HotspotName,
        //                HotspotSpliceName = dto.HotspotSpliceName,
        //                Source = dto.Source.ToString(),
        //                Password = dto.Password
        //            };
        //            await _dataOrderRepository.AddAsync(dataOrder, cancellationToken);
        //        }
        //        else
        //        {
        //            //修改
        //            dataOrder.NewSyncProvinceTime = DateTime.Now;
        //            dataOrder.SyncInterval = new TimeSpan(DateTime.Now.Ticks - dataOrder.FirstSyncProvinceTime.Value.Ticks).TotalSeconds;
        //            dataOrder.IsTimelyUpload = false;
        //            await _dataOrderRepository.UpdateAsync(dataOrder, cancellationToken);
        //        }

        //        //将待推送数据写入待推送表
        //        await InitPushData("SubmitCaseInfo", System.Text.Json.JsonSerializer.Serialize(submitCaseInfo), "submit_case_info", submitCaseInfo.Id, 10, cancellationToken);

        //        //推送数据
        //        //   await _pusherProviderService.ProvinceOrderCreatedPusher(submitCaseInfo, cancellationToken);

        //        //处理附件
        //        await FileData(dto.FileJson, submitCaseInfo.CaseSerial, submitCaseInfo.CliengGuid, submitCaseInfo.AreaCode, cancellationToken);
        //    }
        //}

        ///// <summary>
        /////热线工单期满时间变更--推送服务工单受理---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task HotlineOrderFlowRecalled(OrderDto dto, CancellationToken cancellationToken)
        //{
        //    //如果不是省上派下来的工单，需要汇聚到省上
        //    if (!dto.IsProvince)
        //    {
        //        var submitCaseInfo = await InitData(dto, cancellationToken);

        //        //将待推送数据写入待推送表
        //        await InitPushData("SubmitCaseInfo", System.Text.Json.JsonSerializer.Serialize(submitCaseInfo), "submit_case_info", submitCaseInfo.Id, 10, cancellationToken);

        //        //推送数据
        //        //await _pusherProviderService.ProvinceOrderCreatedPusher(submitCaseInfo, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 热线工单办理---服务工单处理/服务工单交办处理过程----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SubmitCaseProcess(OrderFlowDto dto, CancellationToken cancellationToken)
        //{
        //    //判断是否是热线中心
        //    if (!string.IsNullOrEmpty(dto.Order.ActualHandleOrgCode))
        //    {
        //        if (dto.Order.ActualHandleOrgCode.Substring(0, 3) == "001")
        //        {
        //            dto.Order.ActualHandleOrgName = "热线中心";
        //        }
        //    }

        //    //写本地办理数据-用于查询办理流程
        //    var orderWorkFlow = _mapper.Map<DsOrderWorkFlow>(dto.WorkflowTrace);
        //    orderWorkFlow.OrderId = dto.Order.Id;
        //    _logger.LogInformation("流程转换前数据", System.Text.Json.JsonSerializer.Serialize(dto));
        //    _logger.LogInformation("流程转换后数据", System.Text.Json.JsonSerializer.Serialize(orderWorkFlow));

        //    await _dataOrderWorkFlowRepository.AddAsync(orderWorkFlow, cancellationToken);

        //    //省上下来的工单走协同的接口
        //    if (dto.Order.Source == ESource.ProvinceStraight && dto.Order.IsProvince)
        //    {

        //        var data = _mapper.Map<DsGetCaseProcessReceive>(dto);
        //        data.TacheName = "70:" + data.DeptName;
        //        data.CliengGuid = Guid.NewGuid().ToString();
        //        //将上报信息写入本地库
        //        data.Id = await _getCaseProcessReceiveRepository.AddAsync(data, cancellationToken);
        //        //将待推送数据写入待推送表
        //        await InitPushData("GetCaseProcessReceive", System.Text.Json.JsonSerializer.Serialize(data), "get_case_process_receive", data.Id, 0, cancellationToken);

        //        //信息上报
        //        //await _pusherProviderService.GetCaseProcessReceivePusher(data, cancellationToken);

        //        //处理附件
        //        await FileData(dto.WorkflowTrace.FileJson, data.CaseSerial, data.CliengGuid, dto.Order.AreaCode, cancellationToken);
        //    }
        //    else  //如果不是省上派下来的工单
        //    {
        //        //期满时间变更，重新推送数据
        //        if (dto.ExpiredTimeChanged)
        //        {
        //            var submitCaseInfo = await InitData(dto.Order, cancellationToken);
        //            //将待推送数据写入待推送表
        //            await InitPushData("SubmitCaseInfo", System.Text.Json.JsonSerializer.Serialize(submitCaseInfo), "submit_case_info", submitCaseInfo.Id, 10, cancellationToken);

        //            //推送数据
        //            //  await _pusherProviderService.ProvinceOrderCreatedPusher(submitCaseInfo, cancellationToken);
        //        }

        //        //推送办理记录
        //        await SubmitCaseProcessData(dto, cancellationToken);//本地工单走市州接口

        //    }

        //    //这里判断是否需要往其他平台推送数据
        //    await OrderDispatch(dto, cancellationToken);
        //}

        ///// <summary>
        ///// 回访完成---服务工单回访评价/服务工单交办评价-----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SubmitVisitInfo(PublishVisitDto dto, CancellationToken cancellationToken)
        //{

        //    await SubmitVisitInfoData(dto, cancellationToken);
        //}

        ///// <summary>
        ///// 甄别通过---服务工单回访评价//服务工单交办评价----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SubmitOrderScreenSuccess(PublishVisitDto dto, CancellationToken cancellationToken)
        //{
        //    await SubmitVisitInfoData(dto, cancellationToken);
        //}

        ///// <summary>
        /////热线工单归档---服务工单结果/服务工单交办处理结果----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task OrderFiled(OrderFlowDto dto, CancellationToken cancellationToken)
        //{
        //    //判断是否是热线中心
        //    if (!string.IsNullOrEmpty(dto.Order.ActualHandleOrgCode))
        //    {
        //        if (dto.Order.ActualHandleOrgCode.Substring(0, 3) == "001")
        //        {
        //            dto.Order.ActualHandleOrgName = "热线中心";
        //        }
        //    }
        //    //IsProvince 如果是false 则推送服务工单受理
        //    if (dto != null && dto.Order != null && !dto.Order.IsProvince)
        //    {
        //        //推送工单信息
        //        var submitCaseInfo = await InitData(dto.Order, cancellationToken);

        //        await InitPushData("SubmitCaseInfo", System.Text.Json.JsonSerializer.Serialize(submitCaseInfo), "submit_case_info", submitCaseInfo.Id, 10, cancellationToken);
        //        // await _pusherProviderService.ProvinceOrderCreatedPusher(submitCaseInfo, cancellationToken);
        //        //推送服务工单结果信息-组装110数据
        //        await SubmitCaseResult(dto, cancellationToken);
        //    }

        //    //修改本地工单数据
        //    var data = await _dataOrderRepository.GetAsync(p => p.OrderId == dto.Order.Id, cancellationToken);
        //    if (data != null)
        //    {
        //        data.HandleState = "办理完成";
        //        data.ActualHandleOrgName = dto.WorkflowTrace.HandlerOrgName;
        //        data.ActualHandleOrgCode = dto.WorkflowTrace.HandlerOrgAreaCode;
        //        data.ActualOpinion = dto.WorkflowTrace.Opinion;
        //        data.ActualHandleTime = dto.WorkflowTrace.HandleTime;
        //        await _dataOrderRepository.UpdateAsync(data, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 挂电话推送----电话记录---1
        ///// </summary>
        ///// <param name="dtos"></param>
        ///// <returns></returns>
        //public async Task SubmitCaseRecord(List<CallConnectOrderDto> dtos, CancellationToken cancellationToken)
        //{
        //    List<DsSubmitCaseRecord> recordList = new();
        //    foreach (var item in dtos)
        //    {
        //        var record = _mapper.Map<DsSubmitCaseRecord>(item);
        //        record.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;

        //        if (item.Order != null && !string.IsNullOrEmpty(item.Order.ProvinceNo))
        //            record.CaseSerial = item.Order.ProvinceNo;

        //        //将上报信息写入本地库
        //        record.Id = await _submitCaseRecordRepository.AddAsync(record, cancellationToken);
        //        if (!string.IsNullOrEmpty(record.Id))
        //            await InitPushData("SubmitCaseRecord", System.Text.Json.JsonSerializer.Serialize(record), "submit_case_record", record.Id, 11, cancellationToken);
        //        // recordList.Add(record);
        //    }
        //    //if (recordList != null && recordList.Count > 0)
        //    //    //信息上报
        //    //    await _pusherProviderService.SubmitCaseRecordPusher(recordList, cancellationToken);
        //}

        ///// <summary>
        ///// 关联工单了推送----电话记录---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SubmitCaseRecordOrder(CallConnectOrderDto dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsSubmitCaseRecord>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    data.CaseSerial = dto.Order.ProvinceNo;
        //    //将上报信息写入本地库
        //    data.Id = await _submitCaseRecordRepository.AddAsync(data, cancellationToken);

        //    await InitPushData("SubmitCaseRecord", System.Text.Json.JsonSerializer.Serialize(data), "submit_case_record", data.Id, 11, cancellationToken);
        //    //信息上报
        //    // await _pusherProviderService.SubmitCaseRecordPusher(new List<DsSubmitCaseRecord> { data }, cancellationToken);
        //}

        ///// <summary>
        ///// 统计数据
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SubmitCaseTotal(CaseTotal dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsSubmitCaseTotal>(dto);
        //    //将上报信息写入本地库
        //    var id = await _submitCaseTotalRepository.AddAsync(data);

        //    data.Id = id;
        //    await InitPushData("SubmitCaseTotal", System.Text.Json.JsonSerializer.Serialize(data), "submit_case_total", data.Id, 0, cancellationToken);
        //    //信息上报
        //    //await _pusherProviderService.SubmitCaseTotalPusher(data, cancellationToken);
        //}

        //#endregion

        //#region 协同-第三批次
        ///// <summary>
        ///// 服务工单上报  --- 在派单的时候，确定需不需要往各个平台推送数据--已在工单办理推送事件中处理完成
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SendCaseInfo(OrderDto dto, CancellationToken cancellationToken)
        //{
        //    var sendCaseInfo = _mapper.Map<DsSendCaseInfo>(dto);

        //    //处理性别
        //    switch (dto.FromGender)
        //    {
        //        case EGender.Female:
        //            sendCaseInfo.AppLicantSex = "0";
        //            break;
        //        case EGender.Male:
        //            sendCaseInfo.AppLicantSex = "1";
        //            break;
        //        case EGender.Unknown:
        //            sendCaseInfo.AppLicantSex = "2";
        //            break;
        //        default:
        //            sendCaseInfo.AppLicantSex = "2";
        //            break;
        //    }

        //    //处理证件类型
        //    sendCaseInfo.CertifiCateType = dto.LicenceTypeCode switch
        //    {
        //        "10" => "10",
        //        "40" => "20",
        //        "55" => "30",
        //        "57" => "40",
        //        _ => "50",
        //    };

        //    //处理紧急程度
        //    sendCaseInfo.CaseIsUrgent = dto.EmergencyLevel switch
        //    {
        //        EEmergencyLevel.QuiteEmergency => "10",
        //        EEmergencyLevel.Emergency => "20",
        //        _ => "30",
        //    };

        //    //处理诉求类型
        //    switch (sendCaseInfo.CaseType)
        //    {
        //        case "10":
        //        case "15":
        //        case "20":
        //        case "25":
        //        case "30":
        //        case "35":
        //            break;
        //        default:
        //            sendCaseInfo.CaseType = "40";
        //            break;
        //    }

        //    sendCaseInfo.Id = await _sendCaseInfoRepository.AddAsync(sendCaseInfo, cancellationToken);

        //    //  await _mediator.Publish(new SendCaseInfoNotification(sendCaseInfo));
        //}

        ///// <summary>
        ///// 上报补充诉求---需要再次确认
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SupplyCaseInfoSend(SupplyCaseInfoSendInfo dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsSupplyCaseInfoSend>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    data.CliengGuid = Guid.NewGuid().ToString();
        //    //将上报信息写入本地库
        //    data.Id = await _supplyCaseInfoSendRepository.AddAsync(data);

        //    await InitPushData("SupplyCaseInfoSend", System.Text.Json.JsonSerializer.Serialize(data), "supply_case_info_send", data.Id, 0, cancellationToken);

        //    //信息上报
        //    //await _pusherProviderService.SupplyCaseInfoSendPusher(data, cancellationToken);

        //    //处理附件
        //    await FileData(new List<FileJson>(), dto.CaseSerial, data.CliengGuid, dto.AreaCode, cancellationToken);
        //}

        ///// <summary>
        ///// 撤单----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <param name="cancellationToken"></param>
        ///// <returns></returns>
        //public async Task RevokeOrder(PublishSpecialDto dto, CancellationToken cancellationToken)
        //{
        //    //企业服务
        //    if (dto.Order.CurrentHandleOrgCode == "001180")
        //    {
        //        DsDataWorkOrderCancel dsDataWork = new()
        //        {
        //            WorkOrderNo = dto.Order.No,
        //            Reason = dto.Special.Reason
        //        };
        //        await _enterpriseService.EnterpriseCancelPusher(dsDataWork, cancellationToken);
        //    }

        //    //省12345
        //    if (dto.Order.CurrentHandleOrgCode == "001170")
        //    {
        //        DsRevokeCaseInfo dsRevoke = new()
        //        {
        //            CaseSerial = dto.Order.ProvinceNo,
        //            AreaCode = dto.Order.AreaCode,
        //            RevokeTime = dto.Special.CreationTime,
        //            RevokeName = dto.Special.CreatorName,
        //            RevokeReasion = dto.Special.Reason,
        //            Direction = "1",
        //            CliengGuid = Guid.NewGuid().ToString()
        //        };

        //        if (string.IsNullOrEmpty(dto.Special.Cause))
        //            dsRevoke.RevokeType = "other";
        //        else if (dto.Special.Cause.Contains("内容错误"))
        //            dsRevoke.RevokeType = "2";
        //        else if (dto.Special.Cause == "撤销工单")
        //            dsRevoke.RevokeType = "1";
        //        else
        //            dsRevoke.RevokeType = "other";

        //        //将上报信息写入本地库
        //        dsRevoke.Id = await _revokeCaseInfoRepository.AddAsync(dsRevoke);
        //        await InitPushData("SendRevokeCaseInfo", System.Text.Json.JsonSerializer.Serialize(dsRevoke), "revoke_case_info", dsRevoke.Id, 0, cancellationToken);

        //        await FileData(dto.Special.FileJson, dsRevoke.CaseSerial, dsRevoke.CliengGuid, dsRevoke.AreaCode, cancellationToken);
        //    }
        //}

        ///// <summary>
        ///// 服务工单催单--已对接----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SendRemindCaseInfo(PublishUrgeDto dto, CancellationToken cancellationToken)
        //{
        //    //被催办部门为省上，才能调用接口
        //    if (dto.Urge.OrgName == "")
        //    {
        //        var data = _mapper.Map<DsRemindCaseInfo>(dto);
        //        data.Direction = "1";
        //        data.CliengGuid = Guid.NewGuid().ToString();
        //        //将上报信息写入本地库
        //        data.Id = await _remindCaseInfoRepository.AddAsync(data);

        //        //信息上报
        //        await InitPushData("SendRemindCaseInfo", System.Text.Json.JsonSerializer.Serialize(data), "remind_case_info", data.Id, 0, cancellationToken);
        //        //await _pusherProviderService.SendRemindCaseInfoPusher(data, cancellationToken);

        //        //处理附件
        //        await FileData(dto.Urge.FileJson, dto.Order.ProvinceNo, data.CliengGuid, dto.Order.AreaCode, cancellationToken);
        //    }
        //}

        //#endregion

        //#region 协同-第四批次

        //#region 知识库--已对接附件
        ///// <summary>
        ///// 知识库上报----1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task GetKnowledgeInfoSend(KnowledgeSendDto dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsGetKnowledgeInfoSend>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    data.CliengGuid = Guid.NewGuid().ToString();
        //    if (data.DisableDate == null)//如果没得有失效时间，默认在生效日期上面加10年
        //        data.DisableDate = data.BeginDate.Value.AddYears(10);
        //    //将上报信息写入本地库
        //    data.Id = await _getKnowledgeInfoSendRepository.AddAsync(data);

        //    //查询原有数据，如果有修改原始数据，没有直接新增
        //    var dataRaw = await _knowledgeRawDataRepository.GetAsync(p => p.UID == data.UID);
        //    var raw = _mapper.Map<DsKnowledgeRawData>(data);
        //    if (dataRaw != null)
        //    {
        //        raw.Id = dataRaw.Id;
        //        await _knowledgeRawDataRepository.UpdateAsync(raw);
        //    }
        //    else
        //        await _knowledgeRawDataRepository.AddAsync(raw);

        //    //信息上报
        //    await InitPushData("GetKnowledgeInfoSend", System.Text.Json.JsonSerializer.Serialize(data), "get_knowledge_info_send", data.Id, 0, cancellationToken);
        //    // await _pusherProviderService.GetKnowledgeInfoSendPusher(data, cancellationToken);
        //    //知识附件处理
        //    await FileData(dto.FileJson, dto.UID, data.CliengGuid, data.AreaCode, cancellationToken);

        //}

        ///// <summary>
        ///// 知识库变更---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task GetKnowledgeInfoUpdate(KnowledgeSendDto dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsGetKnowledgeInfoUpdate>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    data.CliengGuid = Guid.NewGuid().ToString();
        //    if (data.DisableDate == null)//如果没得有失效时间，默认在生效日期上面加10年
        //        data.DisableDate = data.BeginDate.Value.AddYears(10);
        //    //将上报信息写入本地库
        //    data.Id = await _getKnowledgeInfoUpdateRepository.AddAsync(data);

        //    //查询原有数据，如果有修改原始数据，没有直接新增
        //    var dataRaw = await _knowledgeRawDataRepository.GetAsync(p => p.UID == data.UID);
        //    var raw = _mapper.Map<DsKnowledgeRawData>(data);
        //    if (dataRaw != null)
        //    {
        //        raw.Id = dataRaw.Id;
        //        await _knowledgeRawDataRepository.UpdateAsync(raw);
        //    }
        //    else
        //        await _knowledgeRawDataRepository.AddAsync(raw);

        //    //信息上报
        //    await InitPushData("GetKnowledgeInfoUpdate", System.Text.Json.JsonSerializer.Serialize(data), "get_knowledge_info_update", data.Id, 0, cancellationToken);
        //    // await _pusherProviderService.GetKnowledgeInfoUpdatePusher(data, cancellationToken);

        //    //知识附件处理
        //    await FileData(dto.FileJson, dto.UID, data.CliengGuid, data.AreaCode, cancellationToken);
        //}

        ///// <summary>
        ///// 知识库下架---1
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task GetKnowledgeInfoAbandon(KnowledgeSendDto dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsGetKnowledgeInfoAbandon>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    //将上报信息写入本地库
        //    data.Id = await _getKnowledgeInfoAbandonRepository.AddAsync(data);

        //    //知识下架删除原有原始数据
        //    await _knowledgeRawDataRepository.RemoveAsync(p => p.UID == data.UID, false);

        //    //信息上报
        //    await InitPushData("GetKnowledgeInfoAbandon", System.Text.Json.JsonSerializer.Serialize(data), "get_knowledge_info_abandon", data.Id, 0, cancellationToken);
        //    //  await _pusherProviderService.GetKnowledgeInfoAbandonPusher(data, cancellationToken);
        //}
        //#endregion

        ///// <summary>
        ///// 实时服务上报
        ///// </summary>
        ///// <param name="dto"></param>
        ///// <returns></returns>
        //public async Task SendRealTimeStatus(SendRealTimeStatusInfo dto, CancellationToken cancellationToken)
        //{
        //    var data = _mapper.Map<DsSendRealTimeStatus>(dto);
        //    data.AreaCode = _channelConfigurationManager.GetConfigurationCityCode().AreaCode;
        //    //将上报信息写入本地库
        //    data.Id = await _sendRealTimeStatusRepository.AddAsync(data);

        //    //信息上报
        //    await InitPushData("SendRealTimeStatus", System.Text.Json.JsonSerializer.Serialize(data), "sendrealtimestatus", data.Id, 0, cancellationToken);
        //    // await _pusherProviderService.SendRealTimeStatusPusher(data, cancellationToken);
        //}
        //#endregion

        //[CapSubscribe(EventNames.HotlineOrderFlowStarted)]
        //public async Task AddOrderAsync(OrderDto order, CancellationToken cancellationToken)
        //{
        //    var dsOrder = _mapper.Map<DsOrder>(order);
        //    dsOrder.Data = System.Text.Json.JsonSerializer.Serialize(order);
        //    await _orderRepository.AddAsync(dsOrder, cancellationToken);
        //}

    }
}
